<?php
class ControllerExtensionModuleWrcustomblocks extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/wrcustomblocks');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/module');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$data_save = $this->request->post;
			function alphSort($v1, $v2) {
   				return strcmp($v1["sort_order"], $v2["sort_order"]);
     		};
     		//usort($data_save['items'], "alphSort");
			//$data_save['items'] = array();
			$sort = array();
			foreach ($data_save['items'] as $key => $row) {
				$sort[$key] = $row['sort_order'];
			}
			array_multisort($sort, SORT_ASC, $data_save['items']);
			if (!isset($this->request->get['module_id'])) {
				$this->model_setting_module->addModule('wrcustomblocks', $data_save);
			} else {
				$this->model_setting_module->editModule($this->request->get['module_id'], $data_save);
			}

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
		}

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}

		if (isset($this->error['width'])) {
			$data['error_width'] = $this->error['width'];
		} else {
			$data['error_width'] = '';
		}

		if (isset($this->error['height'])) {
			$data['error_height'] = $this->error['height'];
		} else {
			$data['error_height'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);

		if (!isset($this->request->get['module_id'])) {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('extension/module/wrcustomblocks', 'user_token=' . $this->session->data['user_token'], true)
			);
		} else {
			$data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('module/wrcustomblocks', 'user_token=' . $this->session->data['user_token'] . '&module_id=' . $this->request->get['module_id'], true)
			);
		}

		if (!isset($this->request->get['module_id'])) {
			$data['action'] = $this->url->link('extension/module/wrcustomblocks', 'user_token=' . $this->session->data['user_token'], true);
		} else {
			$data['action'] = $this->url->link('extension/module/wrcustomblocks', 'user_token=' . $this->session->data['user_token'] . '&module_id=' . $this->request->get['module_id'], true);
		}

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);

		if (isset($this->request->get['module_id']) && ($this->request->server['REQUEST_METHOD'] != 'POST')) {
			$module_info = $this->model_setting_module->getModule($this->request->get['module_id']);
		} else {
			$module_info = array();
			if (isset($this->request->post['items'])) {
				$module_info['items'] = $this->request->post['items'];
			} else {
				$module_info['items'] = array(array(
					'id' => 1,
					'sort_order' => 0,
					'title' => '',
					'image' => '',
					'description' => '',
					'p' => '',
					'link' => '',
					'type' => '',
					'banner_id'      => '',
        			'banner_view'      => '',
        			'status'      => '',
					'thumb' => '',
					'css' => '',
					'w' => '',
					'h' => ''
				));
			}
			
			$module_info['name'] = '';
			$module_info['class'] = '';
			$module_info['styles'] = '';
			$module_info['width'] = '';
			$module_info['height'] = '';
			$module_info['status'] = '0';
			$module_info['displaytitle'] = '1';
		}
		$data['user_token'] = $this->session->data['user_token'];

		$this->load->model('design/banner');
        $data['banners'] = $this->model_design_banner->getBanners();

		if (isset($this->request->post['name'])) {
			$data['name'] = $this->request->post['name'];
		} elseif (!empty($module_info)) {
			$data['name'] = $module_info['name'];
		} else {
			$data['name'] = '';
		}
		$this->load->model('tool/image');
		$item = array();
		$data['items']=array();
		$i=0;
		$data['placeholder'] = $this->model_tool_image->resize('no_image.png', 100, 100);

		foreach ($module_info['items'] as $item) {
			//print_r($item);
			$i++;
			$item['id'] = $i;
			if (!$item['image']) {
				$thumb = $data['placeholder'];
			} else {
				$thumb = $this->model_tool_image->resize($item['image'], 100, 100);
			}
			if (!isset($item['banner'])) {
      			$item['banner'] = array('id' => '0','view' => '1');
      		}
			
      		if (empty($item['type'])) {
        		$item['type'] = '1';
      		}
      		if (!isset($item['status'])) {
      			$item['status'] = 1;
      		}
      		if (!isset($item['css'])) {
      			$item['css'] = '';
      		}
      		if (!isset($item['w'])) {
      			$item['w'] = '0';
      		}
      		if (!isset($item['h'])) {
      			$item['h'] = '0';
      		}
      		
			$data['items'][] = array(
				'id' => $i,
				'type' => $item['type'],
				'banner_id'      => $item['banner']['id'],
        		'banner_view'      => $item['banner']['view'],
        		'status'      => $item['status'],
				'title' => $item['title'],
				'link' => $item['link'],
				'image' => $item['image'],
				'sort_order' => $item['sort_order'],
				'thumb' => $thumb,
				'description' => $item['description'],
				'css' => $item['css'],
				'p' => $item['p'],
				'w' => $item['w'],
				'h' => $item['h']
			);

		}
		
		if (isset($this->request->post['tcss'])) {
			$data['tcss'] = $this->request->post['tcss'];
		} elseif (!empty($module_info)) {
			$data['tcss'] = $module_info['tcss'];
		} else {
			$data['tcss'] = '';
		}

		if (isset($this->request->post['innercss'])) {
			$data['innercss'] = $this->request->post['innercss'];
		} elseif (!empty($module_info['innercss'])) {
			$data['innercss'] = $module_info['innercss'];
		} else {
			$data['innercss'] = '';
		}
		
		if (isset($this->request->post['class'])) {
			$data['class'] = $this->request->post['class'];
		} elseif (!empty($module_info)) {
			$data['class'] = $module_info['class'];
		} else {
			$data['class'] = '';
		}

		if (isset($this->request->post['styles'])) {
			$data['styles'] = $this->request->post['styles'];
		} elseif (!empty($module_info)) {
			$data['styles'] = $module_info['styles'];
		} else {
			$data['styles'] = '';
		}

		if (isset($this->request->post['width'])) {
			$data['width'] = $this->request->post['width'];
		} elseif (!empty($module_info)) {
			$data['width'] = $module_info['width'];
		} else {
			$data['width'] = 200;
		}

		if (isset($this->request->post['height'])) {
			$data['height'] = $this->request->post['height'];
		} elseif (!empty($module_info)) {
			$data['height'] = $module_info['height'];
		} else {
			$data['height'] = 200;
		}

		if (isset($this->request->post['status'])) {
			$data['status'] = $this->request->post['status'];
		} elseif (!empty($module_info)) {
			$data['status'] = $module_info['status'];
		} else {
			$data['status'] = '';
		}
		if (isset($this->request->post['slider'])) {
			$data['slider'] = $this->request->post['slider'];
		} elseif (isset($module_info['slider'])) {
			$data['slider'] = $module_info['slider'];
		} else {
			$data['slider'] = '0';
		}
		if (isset($this->request->post['slider_num'])) {
			$data['slider_num'] = $this->request->post['slider_num'];
		} elseif (isset($module_info['slider_num'])) {
			$data['slider_num'] = $module_info['slider_num'];
		} else {
			$data['slider_num'] = '1';
		}


		if (isset($this->request->post['displaytitle'])) {
			$data['displaytitle'] = $this->request->post['displaytitle'];
		} elseif (!empty($module_info)) {
			$data['displaytitle'] = $module_info['displaytitle'];
		} else {
			$data['displaytitle'] = '';
		}

		
		

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/wrcustomblocks', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/wrcustomblocks')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if ((utf8_strlen($this->request->post['name']) < 3) || (utf8_strlen($this->request->post['name']) > 64)) {
			$this->error['name'] = $this->language->get('error_name');
		}

		return !$this->error;
	}
}